using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 分数答案表
    /// </summary>
    public partial class T_Que_Question_Map
    {
        public T_Que_Question_Map()
        { }
        #region  BasicMethod

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(long Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Que_Question_Map");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.BigInt)
            };
            parameters[0].Value = Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public long Add(Model.T_Que_Question_Map model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Que_Question_Map(");
            strSql.Append("WorkOrderId,QuestionId,TotalScore,Score,CreateBy,AnswersTitle,QuestionIId,CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@WorkOrderId,@QuestionId,@TotalScore,@Score,@CreateBy,@AnswersTitle,@QuestionIId,@CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@WorkOrderId", SqlDbType.VarChar,20),
                    new SqlParameter("@QuestionId", SqlDbType.Int,4),
                    new SqlParameter("@TotalScore", SqlDbType.Int,4),
                    new SqlParameter("@Score", SqlDbType.Int,4),
                    new SqlParameter("@CreateBy", SqlDbType.VarChar,20),
                    new SqlParameter("@AnswersTitle", SqlDbType.NVarChar,50),
                    new SqlParameter("@QuestionIId", SqlDbType.Int,4),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.WorkOrderId;
            parameters[1].Value = model.QuestionId;
            parameters[2].Value = model.TotalScore;
            parameters[3].Value = model.Score;
            parameters[4].Value = model.CreateBy;
            parameters[5].Value = model.AnswersTitle;
            parameters[6].Value = model.QuestionIId;
            parameters[7].Value = model.CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt64(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Que_Question_Map model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Que_Question_Map set ");
            strSql.Append("WorkOrderId=@WorkOrderId,");
            strSql.Append("QuestionId=@QuestionId,");
            strSql.Append("TotalScore=@TotalScore,");
            strSql.Append("Score=@Score,");
            strSql.Append("CreateBy=@CreateBy,");
            strSql.Append("AnswersTitle=@AnswersTitle,");
            strSql.Append("QuestionIId=@QuestionIId,");
            strSql.Append("CreateTime=@CreateTime");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@WorkOrderId", SqlDbType.VarChar,20),
                    new SqlParameter("@QuestionId", SqlDbType.Int,4),
                    new SqlParameter("@TotalScore", SqlDbType.Int,4),
                    new SqlParameter("@Score", SqlDbType.Int,4),
                    new SqlParameter("@CreateBy", SqlDbType.VarChar,20),
                    new SqlParameter("@AnswersTitle", SqlDbType.NVarChar,50),
                    new SqlParameter("@QuestionIId", SqlDbType.Int,4),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@Id", SqlDbType.BigInt,8)};
            parameters[0].Value = model.WorkOrderId;
            parameters[1].Value = model.QuestionId;
            parameters[2].Value = model.TotalScore;
            parameters[3].Value = model.Score;
            parameters[4].Value = model.CreateBy;
            parameters[5].Value = model.AnswersTitle;
            parameters[6].Value = model.QuestionIId;
            parameters[7].Value = model.CreateTime;
            parameters[8].Value = model.Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(long Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Que_Question_Map ");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.BigInt)
            };
            parameters[0].Value = Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(string WorkOrderId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Que_Question_Map ");
            strSql.Append(" where WorkOrderId=@WorkOrderId");
            SqlParameter[] parameters = {
                    new SqlParameter("@WorkOrderId", SqlDbType.VarChar)
            };
            parameters[0].Value = WorkOrderId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Que_Question_Map ");
            strSql.Append(" where Id in (" + Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Que_Question_Map GetModel(long Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 Id,WorkOrderId,QuestionId,TotalScore,Score,AnswersTitle,QuestionIId,CreateBy,CreateTime from T_Que_Question_Map ");
            strSql.Append(" where Id=@Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.BigInt)
            };
            parameters[0].Value = Id;

            Model.T_Que_Question_Map model = new Model.T_Que_Question_Map();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Que_Question_Map DataRowToModel(DataRow row)
        {
            Model.T_Que_Question_Map model = new Model.T_Que_Question_Map();
            if (row != null)
            {
                if (row["Id"] != null && row["Id"].ToString() != "")
                {
                    model.Id = long.Parse(row["Id"].ToString());
                }
                if (row["WorkOrderId"] != null)
                {
                    model.WorkOrderId = row["WorkOrderId"].ToString();
                }
                if (row["QuestionId"] != null && row["QuestionId"].ToString() != "")
                {
                    model.QuestionId = int.Parse(row["QuestionId"].ToString());
                }
                if (row["TotalScore"] != null && row["TotalScore"].ToString() != "")
                {
                    model.TotalScore = int.Parse(row["TotalScore"].ToString());
                }
                if (row["Score"] != null && row["Score"].ToString() != "")
                {
                    model.Score = int.Parse(row["Score"].ToString());
                }
                if (row["AnswersTitle"] != null)
                {
                    model.AnswersTitle = row["AnswersTitle"].ToString();
                }
                if (row["QuestionIId"] != null && row["QuestionIId"].ToString() != "")
                {
                    model.QuestionIId = int.Parse(row["QuestionIId"].ToString());
                }
                if (row["CreateBy"] != null)
                {
                    model.CreateBy = row["CreateBy"].ToString();
                }
                if (row["CreateTime"] != null && row["CreateTime"].ToString() != "")
                {
                    model.CreateTime = DateTime.Parse(row["CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select Id,WorkOrderId,QuestionId,TotalScore,Score,AnswersTitle,QuestionIId,CreateBy,CreateTime ");
            strSql.Append(" FROM T_Que_Question_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" Id,WorkOrderId,QuestionId,TotalScore,Score,AnswersTitle,QuestionIId,CreateBy,CreateTime ");
            strSql.Append(" FROM T_Que_Question_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Que_Question_Map ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Que_Question_Map T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Que_Question_Map";
			parameters[1].Value = "Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
